/*  Copyright © 2016 Zoltán Nagy. All rights reserved.
 *  Created by Zoltán Nagy on 29/08/16.
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef __mc_engine_opts_h__
#define __mc_engine_opts_h__ 1


/*   std includes   */
#include <map>
#include <vector>
#include <climits>
#include <iostream>

/*   project headers   */
#include <bits/duct-tags.h>
#include <bits/duct-dimensionful.h>



namespace duct {
 
  
  /*   Simple structure to provide input parameters for the shower engine.   */
  struct shower_engine_opts
  {
    /*   cutoff kT scale   */
    energy<double> kT_cutoff = 1.0_GeV;
    
    /*   max allowed color suppression   */
    unsigned int max_color_suppression = 4u;
    
    /*   enamble threshold contributions   */
    bool threshold = true;
    
  };
  
  
  /*   fancy print   */
  std::ostream& operator<<(std::ostream&, const shower_engine_opts&);

}

#endif
