/*  Copyright © 2018 Zoltán Nagy. All rights reserved.
 *  Created by Zoltan Nagy on 26.12.18.
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef __math_poly_solve_h__
#define __math_poly_solve_h__ 1



/*   std includes   */
#include <complex>

/*   project headers   */



namespace duct {
 
  /*   finding the roots of a cubic equations    */
  void solve_quadratic(double, double, std::complex<double> *);
  void solve_quadratic(const std::complex<double>&, const std::complex<double>&, std::complex<double> *);
  


  /*   finding the roots of a cubic equations    */
  void solve_qubic(double, double, double, std::complex<double> *);
  void solve_qubic(const std::complex<double>&, const std::complex<double>&, const std::complex<double>&, std::complex<double> *);

  
  
  /*    finding the roots of a quartic equation    */
  void solve_quartic(double, double, double, double, std::complex<double> *);
  
  void solve_quartic(const std::complex<double>&, const std::complex<double>&,
                     const std::complex<double>&, const std::complex<double>&,
                     std::complex<double> *);

  
}   //   namespace duct

#endif /* __math_poly_solve_h__ */
